#!/usr/bin/python3
# ******************************************************************************
# Copyright (c) Huawei Technologies Co., Ltd. 2020-2020. All rights reserved.
# licensed under the Mulan PSL v2.
# You can use this software according to the terms and conditions of the Mulan PSL v2.
# You may obtain a copy of Mulan PSL v2 at:
#     http://license.coscl.org.cn/MulanPSL2
# THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND, EITHER EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT, MERCHANTABILITY OR FIT FOR A PARTICULAR
# PURPOSE.
# See the Mulan PSL v2 for more details.
# ******************************************************************************/

import threading
import time


def func1():
    print(f'这是 func1 线程: {threading.currentThread().name}')


def func2():
    time.sleep(2)
    print(f'这是 func2 线程: {threading.currentThread().name}')
    time.sleep(2)


def func3():
    print(f'这是 func3 线程: {threading.currentThread().name}')
    start_time = time.time()
    thread_list = []
    for i in range(5):
        thread = threading.Thread(target=func2)
        thread_list.append(thread)

    for thr in thread_list:
        thr.start()
    for thr in thread_list:
        thr.join()
    print(f'func3 线程结束: {threading.currentThread().name} 时间为 {time.time() - start_time}')


func3()
func1()
